#ifndef COMMON__SGDEBUG_H
#define	COMMON__SGDEBUG_H

#define SBRK_DEBUG 0 /* Turn on (1) or off (0) sbrk debugging */

#if SBRK_DEBUG 
#define SBRK_MAX_VALUE		 3000000	
#define SBRK_THRESHOLD_VALUE	 2000000
#else
#define SBRK_MAX_VALUE		 0	
#define SBRK_THRESHOLD_VALUE	 0
#endif /* SBRK_DEBUG */

#define SGDEBUG_PRE "DEBUG: C: "
#define SGDEBUG_SUF " [%s] [%s - %d]\n"
#define SBRKDEBUG_SUF_DATA __FILE__, __LINE__
#define SGDEBUG_SUF_DATA timestamp( ), __FILE__, __LINE__

#if SBRK_MAX_VALUE > 0 || SBRK_THRESHOLD_VALUE > 0
#define SBRKDEBUG_CALL ; sbrkdebug( __FILE__, __LINE__ )
#else
#define SBRKDEBUG_CALL
#endif

#define SGDEBUG_LVL_HERE( lvl ) \
  sgdebug( lvl, "DEBUG: C: [%s] [%s - %d]\n", timestamp( ), __FILE__, __LINE__ ) \
  SBRKDEBUG_CALL

#define SGDEBUG_HERE( ) SGDEBUG_LVL_HERE( 0 )

/*
 * Allow for debugging with various levels of verbosity
 */
#define SGDEBUG_LVL_FMT( lvl, fmt ) \
sgdebug( lvl, "DEBUG: C: [%s] : %s [%s - %d]\n", timestamp( ), fmt, __FILE__, __LINE__ ) \
    SBRKDEBUG_CALL

#define SGDEBUG_LVL_FMT_1( lvl, fmt, a1 ) \
sgdebug( lvl, SGDEBUG_PRE fmt SGDEBUG_SUF, a1, SGDEBUG_SUF_DATA ) \
SBRKDEBUG_CALL


#define SGDEBUG_LVL_FMT_2( lvl, fmt, a1, a2 ) \
sgdebug( lvl, SGDEBUG_PRE fmt SGDEBUG_SUF, a1, a2, SGDEBUG_SUF_DATA ) \
SBRKDEBUG_CALL

#define SGDEBUG_LVL_FMT_3( lvl, fmt, a1, a2, a3 ) \
sgdebug( lvl, SGDEBUG_PRE fmt SGDEBUG_SUF, a1, a2, a3, SGDEBUG_SUF_DATA ) \
SBRKDEBUG_CALL

/*
 * These macros have an implicate debug level of 0
 */
#define SGDEBUG_FMT( fmt ) SGDEBUG_LVL_FMT( 0, fmt )
#define SGDEBUG_FMT_1( fmt, a1 ) SGDEBUG_LVL_FMT_1( 0, fmt, a1 )
#define SGDEBUG_FMT_2( fmt, a1, a2 ) SGDEBUG_LVL_FMT_2( 0, fmt, a1, a2 )
#define SGDEBUG_FMT_3( fmt, a1, a2, a3 ) SGDEBUG_LVL_FMT_3( 0, fmt, a1, a2, a3 )

/*
 * Actual work horse function for formatting the debugging information.
 */
void sgdebug( int Level, const char* Format, ... );
void sbrkdebug( const char* File, const int Line );
  
#endif	/* COMMON__SGDEBUG_H */
