/* -*- mode: c++; c-basic-offset: 2; -*- */
%module globus_gass_copy
%{
#include "globus_gass_copy.h"
#include "globus_io.h"
#include "globus_ftp_client.h"      
#include "globus_gass_transfer.h"

#ifdef USE_FTP
#error USE_FTP directive currently not supported
#endif /* USE_FTP */
%}

#ifdef SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS

%exception globus_gass_copy_handle_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_handle_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_handleattr_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_handleattr_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_handleattr_set_ftp_attr GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_set_buffer_length GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_get_buffer_length GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_set_no_third_party_transfers GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_get_no_third_party_transfers GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_get_url_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_attr_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_attr_set_ftp GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_attr_set_io GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_attr_set_gass GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_url_to_url GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_url_to_handle GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_handle_to_url GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_register_url_to_url GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_register_url_to_handle GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_register_handle_to_url GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_get_status GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_cancel GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_cache_url_state GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_flush_url_state GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_set_user_pointer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_get_user_pointer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_register_performance_cb GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_attr_set_tcpbuffer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_attr_set_parallelism GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_attr_set_striping GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_attr_set_authorization GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_copy_attr_set_secure_channel GLOBUS_EXCEPTION_RESULT_T;

#endif /* SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS */

%include "cpointer.i"

/* for globus_off_t */
/* %import "globus_config.h" */

/* for globus_size_t */
%import "globus_common_include.h"

%apply int			* OUTPUT { int * };

%apply globus_off_t		* OUTPUT { globus_off_t * };

%apply globus_bool_t		* OUTPUT { globus_bool_t * };

%apply void			**OUTPUT { void ** };

%apply globus_gass_copy_status_t   * OUTPUT { globus_gass_copy_status_t * };

%apply globus_gass_copy_url_mode_t * OUTPUT { globus_gass_copy_url_mode_t * };

/* The actual file to wrap */
%include "globus_gass_copy.h"

%pointer_functions(globus_gass_copy_handle_t, p_globus_gass_copy_handle_t);
%pointer_functions(globus_gass_copy_attr_t, p_globus_gass_copy_attr_t);
%pointer_functions(globus_gass_copy_handleattr_t,
		   p_globus_gass_copy_handleattr_t);

