/* -*- mode: c++; c-basic-offset: 2; -*- */
%module globus_gass_transfer
%{
#include "globus_gass_transfer.h"
%}

#ifdef SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS

/* GASS Transfer Client Operations */
%exception globus_gass_transfer_register_get GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_get GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_register_put GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_put GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_register_append GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_append GLOBUS_EXCEPTION_RESULT_T;

/* GASS Server Implementation API. */
%exception globus_gass_transfer_create_listener GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_close_listener GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_register_listen GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_register_accept GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_refer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_authorize GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_deny GLOBUS_EXCEPTION_RESULT_T;
/*
%exception globus_gass_transfer_listener_get_base_url GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_listener_get_user_pointer GLOBUS_EXCEPTION_RESULT_T;
*/
%exception globus_gass_transfer_listener_set_user_pointer GLOBUS_EXCEPTION_RESULT_T;

/* Byte send or receive callback function. */
%exception globus_gass_transfer_send_bytes GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_receive_bytes GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_fail GLOBUS_EXCEPTION_RESULT_T;

/* 
%exception globus_gass_transfer_referral_get_count GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_referral_get_url GLOBUS_EXCEPTION_RESULT_T;
*/
%exception globus_gass_transfer_referral_destroy GLOBUS_EXCEPTION_RESULT_T;

/* Request Accessors */
/*
%exception globus_gass_transfer_request_get_type GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_request_get_status GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_request_get_subject GLOBUS_EXCEPTION_RESULT_T;
*/
%exception globus_gass_transfer_request_set_subject GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_request_get_referral GLOBUS_EXCEPTION_RESULT_T;
/*
%exception globus_gass_transfer_request_get_url GLOBUS_EXCEPTION_RESULT_T;
*/
%exception globus_gass_transfer_request_set_url GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_request_get_length GLOBUS_EXCEPTION_RESULT_T;
/*
%exception globus_gass_transfer_request_get_denial_reason GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_request_get_denial_message
GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_request_get_user_pointer GLOBUS_EXCEPTION_RESULT_T;
*/
%exception globus_gass_transfer_request_set_user_pointer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_request_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_request_set_type GLOBUS_EXCEPTION_RESULT_T;

/* Request Attributes */
%exception globus_gass_transfer_requestattr_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_requestattr_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_listenerattr_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_listenerattr_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_requestattr_set_proxy_url GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_requestattr_get_proxy_url GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_requestattr_set_block_size GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_requestattr_get_block_size GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_requestattr_set_file_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_requestattr_get_file_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_requestattr_set_connection_reuse GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_requestattr_get_connection_reuse GLOBUS_EXCEPTION_RESULT_T;

/* Socket Attribute Accessors */
%exception globus_gass_transfer_requestattr_set_socket_sndbuf GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_requestattr_get_socket_sndbuf GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_requestattr_set_socket_rcvbuf GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_requestattr_get_socket_rcvbuf GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_requestattr_set_socket_nodelay GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_requestattr_get_socket_nodelay GLOBUS_EXCEPTION_RESULT_T;

/* Security attribute accessors */
%exception globus_gass_transfer_secure_requestattr_set_authorization GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_secure_requestattr_get_authorization GLOBUS_EXCEPTION_RESULT_T;

/* Listener attributes */
%exception globus_gass_transfer_listenerattr_set_backlog GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_listenerattr_get_backlog GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_listenerattr_set_port GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_listenerattr_get_port GLOBUS_EXCEPTION_RESULT_T;

/* Implementing Request Attributes */
/*
%exception globus_gass_transfer_requestattr_initialize GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_socket_requestattr_initialize GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_secure_requestattr_initialize GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gass_transfer_listenerattr_initialize GLOBUS_EXCEPTION_RESULT_T;
*/
#endif /* SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS */


/* for globus_size_t */
%import "globus_common_include.h"

%apply char			**OUTPUT { char ** };

%apply globus_size_t		* OUTPUT { globus_size_t * };

%apply globus_bool_t		* OUTPUT { globus_bool_t * };

%apply int			* OUTPUT { int * };

%apply unsigned short		* OUTPUT { unsigned short * };

%apply globus_gass_transfer_file_mode_t   * OUTPUT { globus_gass_transfer_file_mode_t * };

%apply globus_gass_transfer_authorization_t   * OUTPUT { globus_gass_transfer_authorization_t * };

%include "cpointer.i"

/* The actual file to wrap */
%include "globus_gass_transfer.h"

#if 0
%pointer_functions(globus_gass_transfer_referral_t,
		   p_globus_gass_transfer_referral_t);


%pointer_functions(globus_gass_transfer_request_t,
		   p_globus_gass_transfer_request_t);

%pointer_functions(globus_gass_transfer_listener_t,
		   p_globus_gass_transfer_listener_t);

#endif /* 0 */

%pointer_functions(globus_gass_transfer_requestattr_t,
		   p_globus_gass_transfer_requestattr_t);

%pointer_functions(globus_gass_transfer_listenerattr_t,
		   p_globus_gass_transfer_listenerattr_t);




