/* -*- mode: c++; c-basic-offset: 2; -*- */

%module globus_gsi_credential
%{
#include "openssl/x509.h"
#include "openssl/bio.h"
#include "openssl/ssl.h"
#include "openssl/asn1.h"  
#include "openssl/safestack.h"
#include "globus_gsi_cred_constants.h"  
#include "globus_gsi_credential.h"
%}

#ifdef SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS

%exception globus_gsi_cred_handle_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_handle_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_handle_copy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_handle_attrs_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_handle_attrs_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_handle_attrs_copy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_read GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_read_proxy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_read_proxy_bio GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_read_proxy_bio GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_read_key GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_read_cert GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_read_pkcs12 GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_write GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_write_proxy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_verify_cert_chain GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_verify GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_X509_subject_name GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_subject_name GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_policies GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_policy_languages GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_issuer_name GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_X509_identity_name GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_identity_name GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_set_cert GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_set_key GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_set_cert_chain GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_cert GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_key GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_cert_chain GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_handle_attrs GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_lifetime GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_goodtill GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_cert_type GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_get_key_bits GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_handle_attrs_set_ca_cert_dir GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_cred_handle_attrs_get_ca_cert_dir GLOBUS_EXCEPTION_RESULT_T;
 
#endif /* SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS */

%ignore globus_gsi_cred_get_path_lengths;
%ignore globus_gsi_cred_handle_init_ssl_context;

#include "openssl/x509.h"
#include "openssl/bio.h"
#include "openssl/ssl.h"
#include "openssl/asn1.h"
%include "openssl/safestack.h"

%import "globus_common_include.h"
%import "globus_gsi_cert_utils_constants.h"
%import "globus_gsi_cred_constants.h"

%include "cpointer.i"

%apply globus_gsi_cred_handle_t *OUTPUT { globus_gsi_cred_handle_t * };

%apply globus_gsi_cred_handle_attrs_t *OUTPUT { globus_gsi_cred_handle_attrs_t * };

%apply globus_gsi_cert_utils_cert_type_t *OUTPUT { globus_gsi_cert_utils_cert_type_t * };

%apply int 		*OUTPUT { int * };

%apply char 		**OUTPUT { char ** };

%apply time_t		*OUTPUT { time_t * };

%include "globus_gsi_credential.h"
