/* -*- mode: c++; c-basic-offset: 2; -*- */

%module globus_gsi_proxy
%{
#include "openssl/evp.h"
#include "proxycertinfo.h"
#include "globus_gsi_proxy.h"
%}

#ifdef SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS

%exception globus_gsi_proxy_handle_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_get_req GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_set_req GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_get_private_key GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_set_private_key GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_get_type GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_set_type GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_get_time_valid GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_set_time_valid GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_set_policy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_get_policy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_set_pathlen GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_get_pathlen GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_clear_cert_info GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_get_proxy_cert_info GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_set_proxy_cert_info GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_get_common_name GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_set_common_name GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_is_limited GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_set_is_limited GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_get_signing_algorithm GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_get_keybits GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_get_init_prime GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_get_clock_skew_allowable GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_get_key_gen_callback GLOBUS_EXCEPTION_RESULT_T;
 
%exception globus_gsi_proxy_handle_attrs_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_attrs_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_attrs_copy GLOBUS_EXCEPTION_RESULT_T;

%exception globus_gsi_proxy_create_req GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_inquire_req GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_sign_req GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_resign_cert GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_assemble_cred GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_create_signed GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_attrs_set_keybits GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_attrs_get_keybits GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_attrs_set_init_prime GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_attrs_get_init_prime GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_attrs_set_signing_algorithm GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_attrs_get_signing_algorithm GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_attrs_set_clock_skew_allowable GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_attrs_get_clock_skew_allowable GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_attrs_get_key_gen_callback GLOBUS_EXCEPTION_RESULT_T;
%exception globus_gsi_proxy_handle_attrs_set_key_gen_callback GLOBUS_EXCEPTION_RESULT_T;
 
#endif /* SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS */

#include "proxycertinfo.h"
#include "globus_gsi_proxy.h"

%import "globus_common_include.h"

%import "globus_gsi_cert_utils_constants.h"

%apply globus_gsi_proxy_handle_t    *OUTPUT { globus_gsi_proxy_handle_t * };

%apply globus_gsi_proxy_handle_attrs_t    *OUTPUT { globus_gsi_proxy_handle_attrs_t * };

%apply globus_gsi_cert_utils_cert_type_t *OUTPUT { globus_gsi_cert_utils_cert_type_t * };

%apply int 		*OUTPUT { int * };

%apply char 		**OUTPUT { char ** };

%apply unsigned char	**OUTPUT { unsigned char ** };

%include "globus_gsi_proxy.h"
