/* -*- mode: c++; c-basic-offset: 2; -*- */
%module globus_io

%{
#include "stdio.h"
#include "globus_io.h"
%}

#ifdef SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS

%exception globus_io_register_close GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_close GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_register_cancel GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_cancel GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_handle_get_user_pointer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_handle_set_user_pointer GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_get_handle_type GLOBUS_EXCEPTION_RESULT_T;

%exception globus_io_register_read GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_try_read GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_read GLOBUS_EXCEPTION_RESULT_T;

%exception globus_io_register_write GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_try_write GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_write GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_register_writev GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_writev GLOBUS_EXCEPTION_RESULT_T;

%exception globus_io_file_open GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_file_seek GLOBUS_EXCEPTION_RESULT_T;

%exception globus_io_file_get_attr GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_file_set_attr GLOBUS_EXCEPTION_RESULT_T;

%exception globus_io_get_handle_type GLOBUS_EXCEPTION_RESULT_T;

%exception globus_io_tcp_register_connect GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcp_connect GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcp_create_listener GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcp_register_listen GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcp_listen GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcp_accept GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcp_register_accept GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcp_get_attr GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcp_set_attr GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcp_get_security_context GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcp_get_delegated_credential GLOBUS_EXCEPTION_RESULT_T;

%exception globus_io_tcpattr_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_fileattr_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcpattr_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_fileattr_destroy GLOBUS_EXCEPTION_RESULT_T;

%exception globus_io_attr_set_file_type GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_file_type GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_set_tcp_restrict_port GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_tcp_restrict_port GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_set_socket_reuseaddr GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_socket_reuseaddr GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_set_socket_keepalive GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_socket_keepalive GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_set_socket_linger GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_socket_linger GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_set_socket_oobinline GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_socket_oobinline GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_set_socket_sndbuf GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_socket_sndbuf GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_set_socket_rcvbuf GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_socket_rcvbuf GLOBUS_EXCEPTION_RESULT_T;

%exception globus_io_attr_set_tcp_nodelay GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_tcp_nodelay GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_set_tcp_interface GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_tcp_interface GLOBUS_EXCEPTION_RESULT_T;

%exception globus_io_attr_set_secure_authentication_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_secure_authentication_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_set_secure_authorization_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_secure_authorization_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_set_secure_extension_oids GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_secure_extension_oids GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_set_secure_channel_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_secure_channel_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_set_secure_delegation_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_secure_delegation_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_set_secure_protection_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_secure_protection_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_set_secure_proxy_mode GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_secure_proxy_mode GLOBUS_EXCEPTION_RESULT_T;

%exception globus_io_attr_set_callback_space GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_attr_get_callback_space GLOBUS_EXCEPTION_RESULT_T;

%exception globus_io_secure_authorization_data_initialize GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_secure_authorization_data_destroy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_secure_authorization_data_set_identity GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_secure_authorization_data_get_identity GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_secure_authorization_data_set_callback GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_secure_authorization_data_get_callback GLOBUS_EXCEPTION_RESULT_T;

/* Unsupported functions within TclGlobus */
#if 0
%exception globus_io_register_select GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_eof GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_file_posix_convert GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcp_posix_convert GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcp_posix_convert_listener GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcp_set_credential GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_tcp_get_credential GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_register_init_delegation GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_init_delegation GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_register_accept_delegation GLOBUS_EXCEPTION_RESULT_T;
%exception globus_io_accept_delegation GLOBUS_EXCEPTION_RESULT_T;
#endif /* 0 */

#endif /* SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS */

/* for globus_off_t */
/* %import "globus_config.h" */

%import "globus_common_include.h"

/* for globus_callback_space_t */
%import "globus_callback.h"

/* gss_cred_id_t */
%import "gssapi.h"

/* globus_callback_space_t */
%import "globus_callback.h"

%include "cpointer.i"

%pointer_functions(globus_io_attr_t, p_globus_io_attr_t);

%pointer_functions(globus_io_handle_t, p_globus_io_handle_t);

%pointer_functions(globus_io_secure_authorization_data_t,
                   p_globus_io_secure_authorization_data_t);

%pointer_functions(globus_netlogger_handle_t, p_globus_netlogger_handle_t);

%apply unsigned short		*INOUT { unsigned short * };

%apply char			**OUTPUT { char ** };

%apply void			**OUTPUT { void ** };

%apply int			*OUTPUT { int * };

%apply OM_uint32		*OUTPUT { OM_uint32 * };

%apply globus_io_file_type_t	*OUTPUT { globus_io_file_type_t * };

%apply globus_size_t		*OUTPUT { globus_size_t * };

%apply globus_bool_t		*OUTPUT { globus_bool_t * };

%apply globus_callback_space_t	*OUTPUT { globus_callback_space_t * };

%apply gss_cred_id_t		*OUTPUT { gss_cred_id_t * };

%apply gss_ctx_id_t		*OUTPUT { gss_ctx_id_t * };

%apply gss_OID_set		*OUTPUT { gss_OID_set * };

%apply globus_io_secure_authentication_mode_t *OUTPUT { globus_io_secure_authentication_mode_t * };

%apply globus_io_secure_authorization_mode_t  *OUTPUT { globus_io_secure_authorization_mode_t * };

%apply globus_io_secure_channel_mode_t        *OUTPUT { globus_io_secure_channel_mode_t * };

%apply globus_io_secure_delegation_mode_t     *OUTPUT { globus_io_secure_delegation_mode_t * };

%apply globus_io_secure_protection_mode_t     *OUTPUT { globus_io_secure_protection_mode_t * };

%apply globus_io_secure_proxy_mode_t          *OUTPUT { globus_io_secure_proxy_mode_t * };

%include "globus_io.h"
