/* -*- mode: c++; c-basic-offset: 2; -*- */
%module globus_xio
%{
#include "stdio.h"
#include "globus_common.h"
#include "globus_common_include.h"
#include "globus_xio_types.h"
#include "globus_xio_load.h"
#include "globus_xio.h"
#include "globus_xio_file_driver.h"
#include "globus_xio_tcp_driver.h"
#include "globus_xio_udp_driver.h"
#include "globus_xio_http.h"
#include "globus_xio_gsi.h"
%}

#ifdef SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS

%exception globus_xio_attr_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_attr_cntl GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_attr_copy GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_attr_destroy GLOBUS_EXCEPTION_RESULT_T;

%exception globus_xio_stack_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_stack_push_driver GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_stack_destroy GLOBUS_EXCEPTION_RESULT_T;

%exception globus_xio_server_create GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_server_get_contact_string GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_server_register_close GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_server_close GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_server_cntl GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_server_accept GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_server_register_accept GLOBUS_EXCEPTION_RESULT_T;

%exception globus_xio_handle_create GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_handle_cntl GLOBUS_EXCEPTION_RESULT_T;

%exception globus_xio_data_descriptor_init GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_data_descriptor_cntl GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_data_descriptor_destroy GLOBUS_EXCEPTION_RESULT_T;

%exception globus_xio_open GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_register_open GLOBUS_EXCEPTION_RESULT_T;

%exception globus_xio_close GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_register_close GLOBUS_EXCEPTION_RESULT_T;

%exception globus_xio_driver_load GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_driver_unload GLOBUS_EXCEPTION_RESULT_T;

%exception globus_xio_read GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_write GLOBUS_EXCEPTION_RESULT_T;

%exception globus_xio_readv GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_writev GLOBUS_EXCEPTION_RESULT_T;

%exception globus_xio_register_read GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_register_write GLOBUS_EXCEPTION_RESULT_T;

%exception globus_xio_register_readv GLOBUS_EXCEPTION_RESULT_T;
%exception globus_xio_register_writev GLOBUS_EXCEPTION_RESULT_T;

#endif /* SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS */

%import "globus_common_include.h"

%apply globus_xio_attr_t            *OUTPUT { globus_xio_attr_t * };
%apply globus_xio_stack_t           *OUTPUT { globus_xio_stack_t * };
%apply globus_xio_handle_t          *OUTPUT { globus_xio_handle_t * };
%apply globus_size_t                *OUTPUT { globus_size_t * };
%apply globus_xio_server_t          *OUTPUT { globus_xio_server_t * };
%apply globus_xio_data_descriptor_t *OUTPUT { globus_xio_data_descriptor_t * };

%apply char **OUTPUT { char ** };

%include "globus_xio_types.h"
%include "globus_xio_load.h"
%include "globus_xio.h"

%include "globus_xio_file_driver.h"
%include "globus_xio_tcp_driver.h"
%include "globus_xio_udp_driver.h"
%include "globus_xio_http.h"
%include "globus_xio_gsi.h"
