/* -*- mode: c++; c-basic-offset: 2; -*- */

%module gssapi
%{

#include "gssapi.h"

/* Had to wrap "GSS_C_NO_NAME" because SWIG doesn't wrap macros that look like:
   ## #define foo (type *) value
*/
static gss_name_t *gss_c_no_name=NULL;
static gss_buffer_t *gss_c_no_buffer=NULL;
static gss_buffer_set_t *gss_c_no_buffer_set=NULL;
static gss_OID *gss_c_null_oid=NULL;
static gss_OID_set *gss_c_no_oid_set=NULL;
static gss_ctx_id_t *gss_c_no_context=NULL;
static gss_cred_id_t *gss_c_no_credential=NULL;
static gss_channel_bindings_t *gss_c_no_channel_bindings=NULL;

%}

%ignore gss_set_group;
%ignore gss_get_group;

%ignore gss_sign;
%ignore gss_verify;
%ignore gss_seal;
%ignore gss_unseal;

/* Had to wrap "GSS_C_NO_NAME" because SWIG doesn't wrap macros that look like:
   ## #define foo (type *) value
*/

static gss_name_t *gss_c_no_name;
static gss_buffer_t *gss_c_no_buffer;
static gss_buffer_set_t *gss_c_no_buffer_set;
static gss_OID *gss_c_null_oid;
static gss_OID_set *gss_c_no_oid_set;
static gss_ctx_id_t *gss_c_no_context;
static gss_cred_id_t *gss_c_no_credential;
static gss_channel_bindings_t *gss_c_no_channel_bindings;

%apply OM_uint32 	*OUTPUT { OM_uint32 * };

%apply int 		*OUTPUT { int * };

%include "gssapi.h"

%include "cpointer.i"
%pointer_functions(gss_cred_id_t, p_gss_cred_id_t);
%pointer_functions(gss_cred_usage_t, p_gss_cred_usage_t);
%pointer_functions(gss_name_t, p_gss_name_t);
%pointer_functions(gss_OID_set, p_gss_OID_set);
%pointer_functions(gss_OID, p_gss_OID);
%pointer_functions(gss_buffer_desc, p_gss_buffer_desc);
%pointer_functions(gss_buffer_t, p_gss_buffer_t);

%pointer_functions(gss_ctx_id_t, p_gss_ctx_id_t);
%pointer_functions(gss_buffer_set_t, p_gss_buffer_set_t);

%include "cdata.i"
/* pick up typedef definitions required to wrap this type */
%import "globus_error.h"


%include "carrays.i"
/* used for display_name to create a buffer.  A crappy, fixed sized buffer, just like pyGlobus */
%clear char *;
%array_functions(char, p_char);

