/* -*- mode: c; basic-c-offset: 2; -*- */
#ifdef SWIG

#include "../../config.h"

/*****************************************************************
 * Hand-wrapped SWIG functions
 *****************************************************************/

%ignore globus_gass_server_ez_init;

%include "tcl-typemaps.i"

%include "swig/globus_gass_server_ez.i"

%{
#include <tcl.h>
#include "tcl-callback.h"
#include "common/sgdebug.h"
#include "common/sginit.h"
%}

/**************************************************************************
 *
 *  SWIG INITIALIZATION STUFF
 *
 **************************************************************************/
%init %{

  SGINIT_X509;

  %}

/**************************************************************************
 **************************************************************************
 *				TYPEMAPS SECTION
 **************************************************************************
 **************************************************************************/

/**************************************************************************
 * GLOBUS_GASS_SERVER_EZ_INIT
 **************************************************************************/
%typemap(in,numinputs=0) globus_gass_transfer_listener_t * listener
{
  $1 = (globus_gass_transfer_listener_t *)
    globus_libc_malloc(sizeof(globus_gass_transfer_listener_t));
}
%typemap(argout,fragment="t_output_helper")
     globus_gass_transfer_listener_t * listener 
{
  Tcl_Obj* o = SWIG_NewPointerObj((void *)($1), $1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

%rename(globus_gass_server_ez_init) tcl_globus_gass_server_ez_init;

%inline %{
  
  int
    tcl_globus_gass_server_ez_init
    ( globus_gass_transfer_listener_t * 	listener,
      globus_gass_transfer_listenerattr_t * 	attr,
      char * 					scheme,
      globus_gass_transfer_requestattr_t * 	reqattr,
      unsigned long 				options )
    {
      int retval;

      retval = globus_gass_server_ez_init( listener,
					   attr,
					   scheme,
					   reqattr,
					   options,
					   NULL );
					         
      return retval;
    }

  %}

#endif /* SWIG */
