/* -*- mode: c; basic-c-offset: 2; -*- */
#ifdef SWIG

%include "../../config.h"

%include "tcl-typemaps.i"

/*****************************************************************
 * Hand-wrapped SWIG functions
 *****************************************************************/

%ignore globus_gsi_cred_handle_attrs_set_search_order;
%ignore globus_gsi_cred_handle_attrs_get_search_order;

%include "swig/globus_gsi_credential.i"

%{

#include <stdio.h>
#include <tcl.h>

#include "tcl-callback.h"
#include "common/sgdebug.h"
#include "common/sginit.h"

%}


/**************************************************************************
 * globus_gsi_cred_handle_attrs_set_search_order 
 **************************************************************************/
%clear char**;

%typemap(in) char **search_order ( char **temp )
{
  Tcl_Obj **listobjv;
  int nitems;
  int i = 0;

  /* Pass in Tcl list of search order */
  if ( Tcl_ListObjGetElements(interp, $input, &nitems, &listobjv) == 
       TCL_ERROR )
    return TCL_ERROR;

  temp = (char **) globus_libc_malloc((nitems+1)*sizeof(char *));

  for (i = 0; i < nitems; i++) 
    {
      temp[i] = Tcl_GetStringFromObj(listobjv[i], 0);
      SGDEBUG_LVL_FMT_1( 20, "search order: %s", temp[i] );
    }
  temp[i] = 0;

  $1 = temp;
}

%rename(globus_gsi_cred_handle_attrs_set_search_order) tcl_globus_gsi_cred_handle_attrs_set_search_order;

%exception tcl_globus_gsi_cred_handle_attrs_set_search_order GLOBUS_EXCEPTION_RESULT_T;

%inline %{
  
  globus_result_t
    tcl_globus_gsi_cred_handle_attrs_set_search_order
    ( globus_gsi_cred_handle_attrs_t      	handle_attrs,
      char					**search_order )
  {
    globus_result_t retval;

    int i = 0;
    while ( search_order[i] )
      {
	SGDEBUG_LVL_FMT_1( 20, "search order: %s", search_order[i] );
	i++;
      }

    retval =
      globus_gsi_cred_handle_attrs_set_search_order
      ( handle_attrs,
	search_order );
    
    return retval;
  }
      
  %}

/**************************************************************************
 * globus_gsi_cred_handle_attrs_get_search_order 
 **************************************************************************/
/* 
 * globus_gsi_cred_type_t * typemap 
 */
%typemap(in,numinputs=0)
  globus_gsi_cred_type_t * search_order[] ($*1_ltype temp) 
{
  $1 = (globus_gsi_cred_type_t *)&temp;
}
%typemap(argout,fragment="t_output_helper")
  globus_gsi_cred_type_t * search_order[]
{
  int index;

  index = 0;
  while ( (*$1)[index] )
    {
      SGDEBUG_LVL_FMT_1( 20, "search order: %s", (*$1)[index] );
      Tcl_Obj* o = Tcl_NewStringObj( (char*)(*$1)[index], -1 );
      Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
      index++;
    }
}

%rename(globus_gsi_cred_handle_attrs_get_search_order ) tcl_globus_gsi_cred_handle_attrs_get_search_order;

%exception tcl_globus_gsi_cred_handle_attrs_get_search_order GLOBUS_EXCEPTION_RESULT_T;

%inline %{
  
  globus_result_t
    tcl_globus_gsi_cred_handle_attrs_get_search_order
    ( globus_gsi_cred_handle_attrs_t      handle_attrs,
      globus_gsi_cred_type_t *            search_order[] )
  {
    globus_result_t retval;

    retval =
      globus_gsi_cred_handle_attrs_get_search_order
      ( handle_attrs,
	search_order );
    
    return retval;
  }
  
  %}
#endif /* SWIG */
