/* -*- indent-tabs-mode: nil; -*- */
#ifndef TCL_CALLBACK_H
#define TCL_CALLBACK_H

#include <tcl.h>
#include <pthread.h>

/* */
typedef struct callbackStruct_ {
  Tcl_Obj*      func;
  Tcl_Obj*      arg;
  pthread_t     s_main_thread_id;
  Tcl_Interp*   s_main_tcl_interp;
  void*         s_api_data;
  void          (*s_pre_process)( struct callbackStruct_* CBstruct );
  int           (*s_post_process)( struct callbackStruct_* CBstruct );
  char          s_vargs[ 1024 ];
} callbackStruct;

void CallCallback( callbackStruct* CallBack, char* Format, ... );

callbackStruct* CreateCallback( Tcl_Interp* Interp, Tcl_Obj* Input );

void TclGlobusCreateUniqueTCLVariableName( char* Buffer );
void TclGlobusCallbackEval( callbackStruct* Callback );

#endif /* TCL_CALLBACK_H */
