/* -*- mode: c; c-basic-offset: 2 -*- */

%include "typemaps.i"

/*
 * ======================================================================
 * typemap(in)
 * ======================================================================
 */
%typemap(in) globus_byte_t* = char*;
%typemap(in) globus_size_t = long;
%typemap(in) OM_uint32 = unsigned int;
%typemap(in) unsigned long * = unsigned long;
%typemap(in) globus_off_t = long long;

/*
 * ======================================================================
 * typemap(out)
 * ======================================================================
 */
%typemap(out) globus_result_t = long;

%typemap(out) globus_size_t *
{
  Tcl_Obj* o = Tcl_NewIntObj( (int)((long)(*$1)) );
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

%typemap(out) globus_byte_t *
{
  Tcl_Obj* o = Tcl_NewStringObj((char*)result, -1);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}
/*
 * ======================================================================
 * OM_uint32 * typemap
 * ======================================================================
 */
%typemap(in,numinputs=0) OM_uint32 *OUTPUT($*1_ltype temp) 
{
  $1 = (OM_uint32 *)&temp;
}
%typemap(argout,fragment="t_output_helper") OM_uint32 *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewIntObj( (int)((long)(*$1)) );
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * ======================================================================
 * a globus_byte ** output typemap
 * ======================================================================
 */
%typemap(in,numinputs=0) globus_byte_t **OUTPUT($*1_ltype temp) {
  $1 = &temp;
}
%typemap(argout,fragment="t_output_helper") globus_byte_t **OUTPUT 
{
  Tcl_Obj* o = Tcl_NewStringObj((char *)(*$1), -1);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
} 

/*
 * ======================================================================
 * a char ** output typemap (the pair is necessary) gleaned from python.i
 * ======================================================================
 */
%typemap(in,numinputs=0) char **OUTPUT($*1_ltype temp) {
  $1 = &temp;
}
%typemap(argout,fragment="t_output_helper") char **OUTPUT 
{
  Tcl_Obj* o = Tcl_NewStringObj((char *)(*$1), -1);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}
/*
 * ======================================================================
 * a unsigned char ** output typemap (the pair is necessary) gleaned from python.i
 * ======================================================================
 */
%typemap(in,numinputs=0) unsigned char **OUTPUT($*1_ltype temp) {
  $1 = &temp;
}
%typemap(argout,fragment="t_output_helper") unsigned char **OUTPUT 
{
  Tcl_Obj* o = Tcl_NewStringObj((char *)(*$1), -1);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}
/*
 * ======================================================================
 * a void ** output typemap (the pair is necessary) gleaned from python.i
 * ======================================================================
 */
%typemap(in,numinputs=0) void **OUTPUT($*1_ltype temp) {
  $1 = &temp;
}
%typemap(argout,fragment="t_output_helper") void **OUTPUT 
{
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}
/*
 * ======================================================================
 * globus_size_t * typemap
 * ======================================================================
 */
%typemap(in,numinputs=0) globus_size_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_size_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_size_t *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewLongObj((long)((long)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}
/*
 * ======================================================================
 * globus_off_t * typemap
 * ======================================================================
 */
%typemap(in,numinputs=0) globus_off_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_off_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_off_t *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewLongObj((long)((long)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}
/*
 * ======================================================================
 * globus_bool_t * typemap
 * ======================================================================
 */
%typemap(in,numinputs=0) globus_bool_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_bool_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_bool_t *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewIntObj((int)((long)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}
/*
 * ======================================================================
 * an unsigned short * output typemap
 * ======================================================================
 */
%typemap(in,numinputs=0) unsigned short *OUTPUT($*1_ltype temp) {
  $1 = (unsigned short *)&temp;
}
%typemap(argout,fragment="t_output_helper") unsigned short *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewIntObj((int)((unsigned short)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}
/*
 * ======================================================================
 * an unsigned long * output typemap
 * ======================================================================
 */
%typemap(in,numinputs=0) unsigned long *OUTPUT($*1_ltype temp) {
  $1 = (unsigned long *)&temp;
}
%typemap(argout,fragment="t_output_helper") unsigned long *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewLongObj((long)((unsigned long)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}
/*
 * ======================================================================
 * a int * output typemap
 * ======================================================================
 */
%typemap(in,numinputs=0) int *OUTPUT($*1_ltype temp) {
  $1 = (int *)&temp;
}
%typemap(argout,fragment="t_output_helper") int *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewIntObj((int)((long)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
} 
/*
 * ======================================================================
 * globus_abstime_t * typemap
 * ======================================================================
 */
%typemap(in,numinputs=0) globus_abstime_t *OUTPUT($*1_ltype temp) 
{
  $1 = &temp;
}
%typemap(argout,fragment="t_output_helper") globus_abstime_t *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewLongObj((long)((long)($1->tv_sec)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );

  o = Tcl_NewLongObj((long)((long)($1->tv_nsec)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}
/*
 * ======================================================================
 * a time_t * output typemap
 * ======================================================================
 */
%typemap(in,numinputs=0) time_t *OUTPUT($*1_ltype temp) {
  $1 = (long int *)&temp;
}
%typemap(argout,fragment="t_output_helper") time_t *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewIntObj((int)((long)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
} 
/*
 * ======================================================================
 * a globus_gsi_statcheck_t * typemap (the pair is necessary) 
 * gleaned from python.i 
 * ======================================================================
 */
%typemap(in,numinputs=0) globus_gsi_statcheck_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_gsi_statcheck_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_gsi_statcheck_t *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewIntObj((int)((long)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}
/*
 * ======================================================================
 * for globus_list.h typemaps
 * ======================================================================
 */

#if 0
%typemap(in,numinputs=0) globus_list_t * volatile *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_list_t *)&temp;
}

%typemap(argout,fragment="t_output_helper") globus_list_t * volatile *OUTPUT 
{
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}
#endif /*0*/
/*
 * ======================================================================
 *		       GLOBUS URL TYPEMAPS
 * ======================================================================
 */
/*
 * globus_url_t * typemap
 */
%typemap(in,numinputs=0) globus_url_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_url_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_url_t *OUTPUT 
{
  Tcl_Obj* o = SWIG_NewPointerObj((void *)($1), $1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * globus_url_scheme_t * typemap
 */
%typemap(in,numinputs=0) globus_url_scheme_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_url_scheme_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_url_scheme_t *OUTPUT 
{
  Tcl_Obj* o = SWIG_NewPointerObj((void *)($1), $1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * ======================================================================
 *		       GSSAPI TYPEMAPS
 * ======================================================================
 */

/* 
 * gss_name_t * typemap 
 */
%typemap(in,numinputs=0) gss_name_t *OUTPUT($*1_ltype temp) 
{
#if 1
  $1 = (gss_name_t *)globus_libc_malloc( sizeof(gss_name_t) );
#else
  $1 = (gss_name_t *)&temp;
#endif  
}
%typemap(argout,fragment="t_output_helper") gss_name_t *OUTPUT 
{
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * ======================================================================
 *		       GRAM CLIENT TYPEMAPS
 * ======================================================================
 */

%typemap(in) (globus_gram_client_callback_func_t callback_func, 
	      void * user_callback_arg) (callbackStruct *cbStruct) 
{
  cbStruct = CreateCallback( interp, $input );

  gs_gram_client_init( cbStruct );
  
  $1 = TclGramCallback; 
  $2 = cbStruct;
  
  cbStruct->s_post_process = gs_gram_client_post_process; 
}

%typemap(in) (globus_gram_client_nonblocking_func_t register_callback, 
	      void * register_callback_arg) (callbackStruct *cbStruct) 
{
  cbStruct = CreateCallback( interp, $input );

  gs_gram_client_init( cbStruct );
  
  $1 = TclGramNonblockingCallback; 
  $2 = cbStruct;

  cbStruct->s_post_process = gs_gram_client_post_process;
}

/*
 * ======================================================================
 *		       GASS COPY TYPEMAPS
 * ======================================================================
 */
/*
 * globus_gass_copy_status_t * typemap
 */
%typemap(in,numinputs=0) globus_gass_copy_status_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_gass_copy_status_t *)&temp;
}
%typemap(argout,fragment="t_output_helper")
     globus_gass_copy_status_t *OUTPUT 
{
  char gass_copy_status[128];
  
  if ( *$1 == GLOBUS_GASS_COPY_STATUS_NONE )
    strcpy(gass_copy_status, "GLOBUS_GASS_COPY_STATUS_NONE");
  else if ( *$1 == GLOBUS_GASS_COPY_STATUS_PENDING )
    strcpy(gass_copy_status, "GLOBUS_GASS_COPY_STATUS_PENDING");
  else if ( *$1 == GLOBUS_GASS_COPY_STATUS_INITIAL )
    strcpy(gass_copy_status, "GLOBUS_GASS_COPY_STATUS_INITIAL");
  else if ( *$1 == GLOBUS_GASS_COPY_STATUS_SOURCE_READY )
    strcpy(gass_copy_status, "GLOBUS_GASS_COPY_STATUS_SOURCE_READY");
  else if ( *$1 == GLOBUS_GASS_COPY_STATUS_TRANSFER_IN_PROGRESS )
    strcpy(gass_copy_status, "GLOBUS_GASS_COPY_STATUS_TRANSFER_IN_PROGRESS");
  else if ( *$1 == GLOBUS_GASS_COPY_STATUS_READ_COMPLETE )
    strcpy(gass_copy_status, "GLOBUS_GASS_COPY_STATUS_READ_COMPLETE");
  else if ( *$1 == GLOBUS_GASS_COPY_STATUS_WRITE_COMPLETE )
    strcpy(gass_copy_status, "GLOBUS_GASS_COPY_STATUS_WRITE_COMPLETE");
  else if ( *$1 == GLOBUS_GASS_COPY_STATUS_DONE )
    strcpy(gass_copy_status, "GLOBUS_GASS_COPY_STATUS_DONE");
  else if ( *$1 == GLOBUS_GASS_COPY_STATUS_FAILURE )
    strcpy(gass_copy_status, "GLOBUS_GASS_COPY_STATUS_FAILURE");
  else if ( *$1 == GLOBUS_GASS_COPY_STATUS_CANCEL )
    strcpy(gass_copy_status, "GLOBUS_GASS_COPY_STATUS_CANCEL");
  else if ( *$1 == GLOBUS_GASS_COPY_STATUS_DONE_SUCCESS )
    strcpy(gass_copy_status, "GLOBUS_GASS_COPY_STATUS_DONE_SUCCESS");
  else if ( *$1 == GLOBUS_GASS_COPY_STATUS_DONE_FAILURE )
    strcpy(gass_copy_status, "GLOBUS_GASS_COPY_STATUS_DONE_FAILURE");
  else if ( *$1 == GLOBUS_GASS_COPY_STATUS_DONE_CANCELLED )
    strcpy(gass_copy_status, "GLOBUS_GASS_COPY_STATUS_DONE_CANCELLED");
  else
    strcpy(gass_copy_status, "Unrecognized status");

  SGDEBUG_LVL_FMT_1(10, "gass_copy_status: %s",  gass_copy_status);
  
  Tcl_Obj* o = Tcl_NewStringObj((char*)gass_copy_status, -1);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * globus_gass_copy_url_mode_t * typemap
 */
%typemap(in,numinputs=0) globus_gass_copy_url_mode_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_gass_copy_url_mode_t *)&temp;
}
%typemap(argout,fragment="t_output_helper")
     globus_gass_copy_url_mode_t *OUTPUT 
{
  char gass_copy_url_mode[128];
  
  if ( *$1 == GLOBUS_GASS_COPY_URL_MODE_UNSUPPORTED )
    strcpy(gass_copy_url_mode, "GLOBUS_GASS_COPY_URL_MODE_UNSUPPORTED");
  else if ( *$1 == GLOBUS_GASS_COPY_URL_MODE_FTP )
    strcpy(gass_copy_url_mode, "GLOBUS_GASS_COPY_URL_MODE_FTP");
  else if ( *$1 == GLOBUS_GASS_COPY_URL_MODE_GASS )
    strcpy(gass_copy_url_mode, "GLOBUS_GASS_COPY_URL_MODE_GASS");
  else if ( *$1 == GLOBUS_GASS_COPY_URL_MODE_IO )
    strcpy(gass_copy_url_mode, "GLOBUS_GASS_COPY_URL_MODE_IO");
  else
    strcpy(gass_copy_url_mode, "Unrecognized URL mode");

  SGDEBUG_LVL_FMT_1(10, "gass_copy_url_mode: %s",  gass_copy_url_mode);
  
  Tcl_Obj* o = Tcl_NewStringObj((char*)gass_copy_url_mode, -1);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * ======================================================================
 *		       GASS TRANSFER TYPEMAPS
 * ======================================================================
 */

#if 0
/* 
 * globus_gass_transfer_request_t * typemap 
 */
%typemap(in,numinputs=0) globus_gass_transfer_request_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_gass_transfer_request_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_gass_transfer_request_t *OUTPUT 
{
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}
#endif
/*
 * globus_gass_transfer_file_mode_t * typemap
 */
%typemap(in,numinputs=0)
     globus_gass_transfer_file_mode_t  *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_gass_transfer_file_mode_t *)&temp;
}
%typemap(argout,fragment="t_output_helper")
     globus_gass_transfer_file_mode_t *OUTPUT 
{
  char file_mode[128];
  
  if ( *$1 == GLOBUS_GASS_TRANSFER_FILE_MODE_BINARY )
    strcpy(file_mode, "GLOBUS_GASS_TRANSFER_FILE_MODE_BINARY");
  else if ( *$1 == GLOBUS_GASS_TRANSFER_FILE_MODE_TEXT )
    strcpy(file_mode, "GLOBUS_GASS_TRANSFER_FILE_MODE_TEXT");
  else
    strcpy(file_mode, "Unrecognized file mode");

  SGDEBUG_LVL_FMT_1(10, "gass_transfer_file_mode: %s",  file_mode);
  
  Tcl_Obj* o = Tcl_NewStringObj((char*)file_mode, -1);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}


/*
 * globus_gass_transfer_authorization_t * typemap
 */
%typemap(in,numinputs=0)
     globus_gass_transfer_authorization_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_gass_transfer_authorization_t *)&temp;
}
%typemap(argout,fragment="t_output_helper")
     globus_gass_transfer_authorization_t *OUTPUT 
{
  char authorization[128];

  SGDEBUG_LVL_FMT_1(10, "gass_transfer_authorization: %d",  *$1);
  
  if ( *$1 == GLOBUS_GASS_TRANSFER_AUTHORIZE_SELF )
    strcpy(authorization, "GLOBUS_GASS_TRANSFER_AUTHORIZE_SELF");
  else if ( *$1 == GLOBUS_GASS_TRANSFER_AUTHORIZE_HOST )
    strcpy(authorization, "GLOBUS_GASS_TRANSFER_AUTHORIZE_HOST");
  else if ( *$1 == GLOBUS_GASS_TRANSFER_AUTHORIZE_SUBJECT )
    strcpy(authorization, "GLOBUS_GASS_TRANSFER_AUTHORIZE_SUBJECT");
  else if ( *$1 == GLOBUS_GASS_TRANSFER_AUTHORIZE_CALLBACK )
    strcpy(authorization, "GLOBUS_GASS_TRANSFER_AUTHORIZE_CALLBACK");
  else
    strcpy(authorization, "Unrecognized authorization");

  SGDEBUG_LVL_FMT_1(10, "gass_transfer_authorization: %s",  authorization);
  
  Tcl_Obj* o = Tcl_NewStringObj((char*)authorization, -1);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * ======================================================================
 *		       FTP CONTROL TYPEMAPS
 * ======================================================================
 */

/* globus_ftp_control_protection_t * typemap */
%typemap(in,numinputs=0)
     globus_ftp_control_protection_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_ftp_control_protection_t *)&temp;
}

%typemap(argout,fragment="t_output_helper")
     globus_ftp_control_protection_t *OUTPUT 
{
  char protection[128];
  
  if ( *$1 == GLOBUS_FTP_CONTROL_PROTECTION_CLEAR )
    strcpy(protection, "GLOBUS_FTP_CONTROL_PROTECTION_CLEAR");
  else if ( *$1 == GLOBUS_FTP_CONTROL_PROTECTION_SAFE )
    strcpy(protection, "GLOBUS_FTP_CONTROL_PROTECTION_SAFE");
  else if ( *$1 == GLOBUS_FTP_CONTROL_PROTECTION_CONFIDENTIAL )
    strcpy(protection, "GLOBUS_FTP_CONTROL_PROTECTION_CONFIDENTIAL");
  else if ( *$1 == GLOBUS_FTP_CONTROL_PROTECTION_PRIVATE )
    strcpy(protection, "GLOBUS_FTP_CONTROL_PROTECTION_PRIVATE");
  else
    strcpy(protection, "Unrecognized FTP control protection");

  Tcl_Obj* o = Tcl_NewStringObj((char*)protection, -1);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

%typemap(in)
  (globus_ftp_control_response_callback_t callback,
   void * callback_arg) (callbackStruct *cbStruct)
{
  cbStruct = CreateCallback( interp, $input );

  $1 = (globus_ftp_control_response_callback_t)TclFTPControlResponseCallback;
  $2 = cbStruct;
}

%typemap(in)
  (globus_ftp_control_callback_t callback,
   void * callback_arg) (callbackStruct *cbStruct)
{
  cbStruct = CreateCallback( interp, $input );

  $1 = (globus_ftp_control_callback_t)TclFTPControlCallback;
  $2 = cbStruct;
}

%typemap(in)
  (globus_ftp_control_callback_t cb,
   void * user_arg) (callbackStruct *cbStruct)
{
  cbStruct = CreateCallback( interp, $input );

  $1 = (globus_ftp_control_callback_t)TclFTPControlCallback;
  $2 = cbStruct;
}


%typemap(in)
  (globus_ftp_control_callback_t destroy_callback,
   void * destroy_callback_arg) (callbackStruct *cbStruct)
{
  cbStruct = CreateCallback( interp, $input );

  $1 = (globus_ftp_control_callback_t)TclFTPControlCallback;
  $2 = cbStruct;
}

%typemap(in)
  (globus_ftp_control_data_connect_callback_t	callback,
   void * user_arg) (callbackStruct *cbStruct)
{
  cbStruct = CreateCallback( interp, $input );

  $1 = TclFTPControlDataConnectCallback;
  $2 = cbStruct;
}

%typemap(in)
  (globus_ftp_control_server_callback_t callback,
   void * callback_arg) (callbackStruct *cbStruct)
{
  cbStruct = CreateCallback( interp, $input );
    
  $1 = (globus_ftp_control_server_callback_t)TclFTPControlServerCallback;
  $2 = cbStruct;
}

%typemap(in)
  (globus_ftp_control_auth_callback_t callback,
   void * callback_arg) (callbackStruct *cbStruct)
{
  cbStruct = CreateCallback( interp, $input );
    
  $1 = (globus_ftp_control_auth_callback_t)TclFTPControlAuthCallback;
  $2 = cbStruct;
}

%typemap(in)
  (globus_ftp_control_command_callback_t callback,
   void * callback_arg) (callbackStruct *cbStruct)
{
  cbStruct = CreateCallback( interp, $input );

  $1 = TclFTPControlReadCommandsCallback;
  $2 = cbStruct;
}


/*
 * ======================================================================
 *		       FTP CLIENT TYPEMAPS
 * ======================================================================
 */
/*
 * globus_ftp_control_type_t * typemap
 */
%typemap(in,numinputs=0)
     globus_ftp_control_type_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_ftp_control_type_t *)&temp;
}
%typemap(argout,fragment="t_output_helper")
     globus_ftp_control_type_t *OUTPUT 
{
  char control_type[128];
  
  if ( *$1 == GLOBUS_FTP_CONTROL_TYPE_NONE )
    strcpy(control_type, "GLOBUS_FTP_CONTROL_TYPE_NONE");
  else if ( *$1 == GLOBUS_FTP_CONTROL_TYPE_ASCII )
    strcpy(control_type, "GLOBUS_FTP_CONTROL_TYPE_ASCII");
  else if ( *$1 == GLOBUS_FTP_CONTROL_TYPE_EBCDIC )
    strcpy(control_type, "GLOBUS_FTP_CONTROL_TYPE_EBCDIC");
  else if ( *$1 == GLOBUS_FTP_CONTROL_TYPE_IMAGE )
    strcpy(control_type, "GLOBUS_FTP_CONTROL_TYPE_IMAGE");
  else if ( *$1 == GLOBUS_FTP_CONTROL_TYPE_LOCAL )
    strcpy(control_type, "GLOBUS_FTP_CONTROL_TYPE_LOCAL");
  else
    strcpy(control_type, "Unrecognized FTP control type");
  
  Tcl_Obj* o = Tcl_NewStringObj((char*)control_type, -1);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * globus_ftp_control_mode_t * typemap
 */
%typemap(in,numinputs=0)
     globus_ftp_control_mode_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_ftp_control_mode_t *)&temp;
}

%typemap(argout,fragment="t_output_helper")
     globus_ftp_control_mode_t *OUTPUT 
{
  char control_mode[128];
  
  if ( *$1 == GLOBUS_FTP_CONTROL_MODE_NONE )
    strcpy(control_mode, "GLOBUS_FTP_CONTROL_MODE_NONE");
  else if ( *$1 == GLOBUS_FTP_CONTROL_MODE_STREAM )
    strcpy(control_mode, "GLOBUS_FTP_CONTROL_MODE_STREAM");
  else if ( *$1 == GLOBUS_FTP_CONTROL_MODE_BLOCK )
    strcpy(control_mode, "GLOBUS_FTP_CONTROL_MODE_BLOCK");
  else if ( *$1 == GLOBUS_FTP_CONTROL_MODE_EXTENDED_BLOCK )
    strcpy(control_mode, "GLOBUS_FTP_CONTROL_MODE_EXTENDED_BLOCK");
  else if ( *$1 == GLOBUS_FTP_CONTROL_MODE_COMPRESSED )
    strcpy(control_mode, "GLOBUS_FTP_CONTROL_MODE_COMPRESSED");
  else
    strcpy(control_mode, "Unrecognized FTP control mode");
        
  Tcl_Obj* o = Tcl_NewStringObj((char*)control_mode, -1);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * globus_ftp_control_protection_t * typemap
 */
%typemap(in,numinputs=0)
     globus_ftp_control_protection_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_ftp_control_protection_t *)&temp;
}

%typemap(argout,fragment="t_output_helper")
     globus_ftp_control_protection_t *OUTPUT 
{
  char control_protection[128];
  
  if ( *$1 == GLOBUS_FTP_CONTROL_PROTECTION_CLEAR )
    strcpy(control_protection, "GLOBUS_FTP_CONTROL_PROTECTION_CLEAR");
  else if ( *$1 == GLOBUS_FTP_CONTROL_PROTECTION_SAFE )
    strcpy(control_protection, "GLOBUS_FTP_CONTROL_PROTECTION_SAFE");
  else if ( *$1 == GLOBUS_FTP_CONTROL_PROTECTION_CONFIDENTIAL )
    strcpy(control_protection, "GLOBUS_FTP_CONTROL_PROTECTION_CONFIDENTIAL");
  else if ( *$1 == GLOBUS_FTP_CONTROL_PROTECTION_PRIVATE )
    strcpy(control_protection, "GLOBUS_FTP_CONTROL_PROTECTION_PRIVATE");
  else
    strcpy(control_protection, "Unrecognized FTP control protection");

  Tcl_Obj* o = Tcl_NewStringObj((char*)control_protection, -1);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}


/*
 * globus_ftp_client_operationattr_set_read_all * typemap
 */
%typemap(in) (globus_ftp_client_data_callback_t intermediate_callbacks,
              void * intermediate_callback_arg) 
     (callbackStruct *cbStruct) 
{
  cbStruct = CreateCallback( interp, $input );
  $1 = FTPClientDataCallback; 
  $2 = cbStruct;
}

/*
 * FTP Client Callbacks
 */

%typemap(in) (globus_ftp_client_complete_callback_t complete_callback, 
	      void * callback_arg) (callbackStruct *cbStruct) 
{
  cbStruct = CreateCallback( interp, $input );
  $1 = FTPClientCompleteCallback; 
  $2 = cbStruct;
}

/*
 * ======================================================================
 * 				GSI CREDENTIAL TYPEMAPS
 * ======================================================================
 */
/* 
 * globus_gsi_cred_handle_t * typemap 
 */
%typemap(in,numinputs=0) globus_gsi_cred_handle_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_gsi_cred_handle_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_gsi_cred_handle_t *OUTPUT
{
#if 0  
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)((globus_gsi_cred_handle_t)(*$1)), SWIGTYPE_globus_gsi_cred_handle_t, 0);
#else
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
#endif  
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/* 
 * globus_gsi_cred_handle_attrs_t * typemap 
 */
%typemap(in,numinputs=0) globus_gsi_cred_handle_attrs_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_gsi_cred_handle_attrs_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_gsi_cred_handle_attrs_t *OUTPUT
{
#if 0  
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)((globus_gsi_cred_handle_attrs_t)(*$1)), SWIGTYPE_globus_gsi_cred_handle_attrs_t, 0);
#else
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
#endif  
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * ======================================================================
 * 				GSI PROXY TYPEMAPS
 * ======================================================================
 */

/*
 * globus_gsi_cert_utils_cert_type_t * typemap
 */
%typemap(in,numinputs=0)
  globus_gsi_cert_utils_cert_type_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_gsi_cert_utils_cert_type_t *)&temp;
}

%typemap(argout,fragment="t_output_helper")
  globus_gsi_cert_utils_cert_type_t *OUTPUT 
{
  char cert_type[128];
  
  if ( *$1 == GLOBUS_GSI_CERT_UTILS_TYPE_EEC )
    strcpy(cert_type, "GLOBUS_GSI_CERT_UTILS_TYPE_EEC");
  else if ( *$1 == GLOBUS_GSI_CERT_UTILS_TYPE_CA )
    strcpy(cert_type, "GLOBUS_GSI_CERT_UTILS_TYPE_CA");
  else if ( *$1 == GLOBUS_GSI_CERT_UTILS_TYPE_GSI_3_IMPERSONATION_PROXY )
    strcpy(cert_type, "GLOBUS_GSI_CERT_UTILS_TYPE_GSI_3_IMPERSONATION_PROXY");
  else if ( *$1 == GLOBUS_GSI_CERT_UTILS_TYPE_GSI_3_INDEPENDENT_PROXY )
    strcpy(cert_type, "GLOBUS_GSI_CERT_UTILS_TYPE_GSI_3_INDEPENDENT_PROXY");
  else if ( *$1 == GLOBUS_GSI_CERT_UTILS_TYPE_GSI_3_LIMITED_PROXY )
    strcpy(cert_type, "GLOBUS_GSI_CERT_UTILS_TYPE_GSI_3_LIMITED_PROXY");
  else if ( *$1 == GLOBUS_GSI_CERT_UTILS_TYPE_GSI_3_RESTRICTED_PROXY )
    strcpy(cert_type, "GLOBUS_GSI_CERT_UTILS_TYPE_GSI_3_RESTRICTED_PROXY");
  else if ( *$1 == GLOBUS_GSI_CERT_UTILS_TYPE_GSI_2_PROXY )
    strcpy(cert_type, "GLOBUS_GSI_CERT_UTILS_TYPE_GSI_2_PROXY");
  else if ( *$1 == GLOBUS_GSI_CERT_UTILS_TYPE_GSI_2_LIMITED_PROXY )
    strcpy(cert_type, "GLOBUS_GSI_CERT_UTILS_TYPE_GSI_2_LIMITED_PROXY");
  else if ( *$1 == GLOBUS_GSI_CERT_UTILS_TYPE_RFC_IMPERSONATION_PROXY )
    strcpy(cert_type, "GLOBUS_GSI_CERT_UTILS_TYPE_RFC_IMPERSONATION_PROXY");
  else if ( *$1 == GLOBUS_GSI_CERT_UTILS_TYPE_RFC_INDEPENDENT_PROXY )
    strcpy(cert_type, "GLOBUS_GSI_CERT_UTILS_TYPE_RFC_INDEPENDENT_PROXY");
  else if ( *$1 == GLOBUS_GSI_CERT_UTILS_TYPE_RFC_LIMITED_PROXY )
    strcpy(cert_type, "GLOBUS_GSI_CERT_UTILS_TYPE_RFC_LIMITED_PROXY");
  else if ( *$1 == GLOBUS_GSI_CERT_UTILS_TYPE_RFC_RESTRICTED_PROXY)
    strcpy(cert_type, "GLOBUS_GSI_CERT_UTILS_TYPE_RFC_RESTRICTED_PROXY");
  else
    strcpy(cert_type, "Unrecognized cert type");

  Tcl_Obj* o = Tcl_NewStringObj((char*)cert_type, -1);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/* 
 * globus_gsi_proxy_handle_attrs_t * typemap 
 */
%typemap(in,numinputs=0) globus_gsi_proxy_handle_attrs_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_gsi_proxy_handle_attrs_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_gsi_proxy_handle_attrs_t *OUTPUT
{
#if 0  
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)((globus_gsi_proxy_handle_attrs_t)(*$1)), SWIGTYPE_globus_gsi_proxy_handle_attrs_t, 0);
#else
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
#endif 
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/* 
 * globus_gsi_proxy_handle_t * typemap 
 */
%typemap(in,numinputs=0) globus_gsi_proxy_handle_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_gsi_proxy_handle_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_gsi_proxy_handle_t *OUTPUT
{
#if 0  
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)((globus_gsi_proxy_handle_t)(*$1)), SWIGTYPE_globus_gsi_proxy_handle_t, 0);
#else
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
#endif
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}


/*
 * ======================================================================
 * 				I/O TYPEMAPS
 * ======================================================================
 */

/*
 * globus_io_file_type_t * typemap
 */
%typemap(in,numinputs=0) globus_io_file_type_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_io_file_type_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_io_file_type_t *OUTPUT 
{
  char file_type[128];

  SGDEBUG_LVL_FMT_1(10, "globus_io_file_type_t: %d",  *$1);
  
  if ( *$1 == GLOBUS_IO_FILE_TYPE_TEXT )
    strcpy(file_type, "GLOBUS_IO_FILE_TYPE_TEXT");
  else if ( *$1 == GLOBUS_IO_FILE_TYPE_BINARY )
    strcpy(file_type, "GLOBUS_IO_FILE_TYPE_BINARY");
  else
    strcpy(file_type, "Unrecognized I/O file type");

  Tcl_Obj* o = Tcl_NewStringObj((char*)file_type, -1);
  //Tcl_Obj* o = Tcl_NewIntObj((int)((long)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * globus_callback_space_t * typemap
 */
%typemap(in,numinputs=0) globus_callback_space_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_callback_space_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_callback_space_t *OUTPUT 
{
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * gss_cred_id_t * typemap
 */
%typemap(in,numinputs=0) gss_cred_id_t *OUTPUT($*1_ltype temp) 
{
  $1 = (gss_cred_id_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") gss_cred_id_t *OUTPUT 
{
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * gss_ctx_id_t * typemap
 */
%typemap(in,numinputs=0) gss_ctx_id_t *OUTPUT($*1_ltype temp) 
{
  $1 = (gss_ctx_id_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") gss_ctx_id_t *OUTPUT 
{
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * globus_io_secure_authentication_mode_t * typemap
 */
%typemap(in,numinputs=0)
     globus_io_secure_authentication_mode_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_io_secure_authentication_mode_t *)&temp;
}
%typemap(argout,fragment="t_output_helper")
     globus_io_secure_authentication_mode_t *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewIntObj((int)((long)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * globus_io_secure_authorization_mode_t * typemap
 */
%typemap(in,numinputs=0)
     globus_io_secure_authorization_mode_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_io_secure_authorization_mode_t *)&temp;
}
%typemap(argout,fragment="t_output_helper")
     globus_io_secure_authorization_mode_t *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewIntObj((int)((long)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * gss_OID_set * typemap
 */
%typemap(in,numinputs=0) gss_OID_set *OUTPUT($*1_ltype temp) 
{
  $1 = (gss_OID_set *)&temp;
}
%typemap(argout,fragment="t_output_helper") gss_OID_set *OUTPUT 
{
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * globus_io_secure_channel_mode_t * typemap
 */
%typemap(in,numinputs=0)
     globus_io_secure_channel_mode_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_io_secure_channel_mode_t *)&temp;
}
%typemap(argout,fragment="t_output_helper")
     globus_io_secure_channel_mode_t *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewIntObj((int)((long)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * globus_io_secure_delegation_mode_t * typemap
 */
%typemap(in,numinputs=0)
     globus_io_secure_delegation_mode_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_io_secure_delegation_mode_t *)&temp;
}
%typemap(argout,fragment="t_output_helper")
     globus_io_secure_delegation_mode_t *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewIntObj((int)((long)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * globus_io_secure_protection_mode_t * typemap
 */
%typemap(in,numinputs=0)
     globus_io_secure_protection_mode_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_io_secure_protection_mode_t *)&temp;
}
%typemap(argout,fragment="t_output_helper")
     globus_io_secure_protection_mode_t *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewIntObj((int)((long)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * globus_io_secure_proxy_mode_t * typemap
 */
%typemap(in,numinputs=0)
     globus_io_secure_proxy_mode_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_io_secure_proxy_mode_t *)&temp;
}
%typemap(argout,fragment="t_output_helper")
     globus_io_secure_proxy_mode_t *OUTPUT 
{
  Tcl_Obj* o = Tcl_NewIntObj((int)((long)(*$1)));
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * globus_io_register_close()
 * globus_io_tcp_register_listen()
 * globus_io_tcp_register_accept()
 */
%typemap(in) (globus_io_callback_t callback, void * callback_arg) 
     (callbackStruct *cbStruct) 
{
  cbStruct = CreateCallback( interp, $input );
  $1 = (globus_io_callback_t)TclIoCallback; 
  $2 = cbStruct;
}

/*
 * globus_io_register_cancel()
 */
%typemap(in) (globus_io_callback_t cancel_callback, void * cancel_arg) 
     (callbackStruct *cbStruct) 
{
  cbStruct = CreateCallback( interp, $input );
  $1 = (globus_io_callback_t)TclIoCallback; 
  $2 = cbStruct;
}

/*
 * globus_io_register_init_delegation()
 * globus_io_register_accept_delegation()
 */
%typemap(in) (globus_io_delegation_callback_t callback, void * callback_arg) 
     (callbackStruct *cbStruct) 
{
  cbStruct = CreateCallback( interp, $input );
  $1 = (globus_io_delegation_callback_t)TclIoDelegationCallback; 
  $2 = cbStruct;
}

/*
 * globus_io_secure_authorization_data_set_callback()
 */
%typemap(in) (globus_io_secure_authorization_callback_t callback,
              void * callback_arg) 
     (callbackStruct *cbStruct) 
{
  cbStruct = CreateCallback( interp, $input );
  
  $1 = (globus_io_secure_authorization_callback_t)TclIoSecureAuthorizationDataSetCallback; 

  $2 = cbStruct;
}

/*
 * ======================================================================
 * 				XIO TYPEMAPS
 * ======================================================================
 */
/* 
 * globus_xio_attr_t * typemap 
 */
%typemap(in,numinputs=0) globus_xio_attr_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_xio_attr_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_xio_attr_t *OUTPUT
{
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/* 
 * globus_xio_stack_t * typemap 
 */
%typemap(in,numinputs=0) globus_xio_stack_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_xio_stack_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_xio_stack_t *OUTPUT 
{
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}
 
/* 
 * globus_xio_handle_t * typemap 
 */
%typemap(in,numinputs=0) globus_xio_handle_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_xio_handle_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_xio_handle_t *OUTPUT 
{
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/* 
 * globus_xio_server_t * typemap 
 */
%typemap(in,numinputs=0) globus_xio_server_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_xio_server_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") globus_xio_server_t *OUTPUT 
{
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/* 
 * globus_xio_data_descriptor_t * typemap 
 */
%typemap(in,numinputs=0) globus_xio_data_descriptor_t *OUTPUT($*1_ltype temp) 
{
  $1 = (globus_xio_data_descriptor_t *)&temp;
}
%typemap(argout,fragment="t_output_helper") 
     globus_xio_data_descriptor_t *OUTPUT 
{
  Tcl_Obj* o = SWIG_NewInstanceObj((void *)(*$1), $*1_descriptor, 0);
  Tcl_ListObjAppendElement( interp, Tcl_GetObjResult(interp), o );
}

/*
 * ======================================================================
 * 				XIO CALLBACKS
 * ======================================================================
 */
/*
 * for globus_xio_server_register_accept()
 */
%typemap(in) (globus_xio_accept_callback_t cb, void * user_arg) 
     (callbackStruct *cbStruct) 
{
  cbStruct = CreateCallback( interp, $input );
  $1 = TclXioAcceptCallback; 
  $2 = cbStruct;
}

/*
 * for globus_xio_server_register_close()
 */
%typemap(in) (globus_xio_server_callback_t cb, void * user_arg) 
     (callbackStruct *cbStruct) 
{
  cbStruct = CreateCallback( interp, $input );
  $1 = TclXioServerCallback; 
  $2 = cbStruct;
}

/*
 * for globus_xio_register_open() & globus_xio_register_close()
 */
%typemap(in) (globus_xio_callback_t cb, void * user_arg) 
     (callbackStruct *cbStruct) 
{
  cbStruct = CreateCallback( interp, $input );
  $1 = TclXioCallback; 
  $2 = cbStruct;
}

/*
 * ======================================================================
 * 				EXCEPTION HANDLERS
 * ======================================================================
 */

#define SCRIPTING_LANGUAGE_SUPPORTS_EXCEPTIONS
%define GLOBUS_EXCEPTION(type)
{
  int error = $action

  if ( error != GLOBUS_SUCCESS )
  {
    Tcl_Obj*	tcl_result = Tcl_GetObjResult( interp );
    char*	msg = (char*)globus_ ## type ## _error_string( error );
    
    Tcl_SetStringObj( tcl_result, msg, strlen( msg ) );

    return TCL_ERROR;
  }
}
%enddef
%define GLOBUS_EXCEPTION_RESULT_T
{
  globus_result_t error = $action

  if ( error != GLOBUS_SUCCESS )
  {
    Tcl_Obj*	tcl_result = Tcl_GetObjResult( interp );

    globus_object_t* error_obj = globus_error_get( error );
    char*	msg = globus_object_printable_to_string( error_obj );

    Tcl_SetStringObj( tcl_result, msg, strlen( msg ) );

    globus_libc_free( msg );

    return TCL_ERROR;
  }
}
%enddef
