#ifndef TCL_VARARG_H
#define TCL_VARARG_H

#include "config.h"

#include "xio_driver.h"
#include "InterpInfo.h"

int
GetVarArgAsInt( driver_call_info_type* Parms,
                unsigned int Offset,
                int* Result );

// Do not free/modify the return value
// Length is the number of bytes in the resulting string
// Return value is the string representation of the object.
char*
GetVarArgAsString( driver_call_info_type* Parms,
                   unsigned int Offset,
                   int* Length );


void
GetVarArgAsPointer( driver_call_info_type* Parms,
                    unsigned int Offset,
                    void* Result );



void
AppendInt( driver_call_info_type* Parms,
           int Value );

void
AppendDouble( driver_call_info_type* Parms,
              double Value );

void
AppendString( driver_call_info_type* Parms,
              char* Value );

void
AppendPointer( driver_call_info_type* Parms,
               void* Value);


#endif /* TCL_VARARG_H */


