#ifndef XIO_DRIVER_H
#define XIO_DRIVER_H

#include "globus_common_include.h"
#include "globus_xio.h"

#define MAX_NAME 128

struct driver_call_info_struct;

typedef struct {
  globus_result_t (*m_function_call)( void* ControlType,
                                      globus_xio_driver_t Driver,
                                      struct driver_call_info_struct* Parms );
#if 0
  void (*m_results_call)( );
#endif /* 0 */
} conv_routine_type;

/* 
 *Conversion routines to handle different attribute settings
 * within Globus XIO
 */
typedef struct {
  conv_routine_type    m_attr_cntl;
  conv_routine_type    m_handle_cntl;
  conv_routine_type    m_server_cntl;
  conv_routine_type    m_data_desc_cntl;
} XIODriverFunctionMap_type;

/* 
 * Driver attr & cntl related typedef 
 */
typedef struct driver_call_info_struct {
  char*                      m_driver_type;    /* driver name */
  int                        m_cmd;            /* XIO cmd enumeration */
  XIODriverFunctionMap_type* m_driver_info;    /* conversion routine */
  int                        m_var_argc;       /* var arg counts */
  void*                      m_var_argv;       /* 1st arg of vararg */
  void*			     m_interp_info;    /* language dependent info */
} driver_call_info_type;

#endif /* XIO_DRIVER_H */
