#!/bin/sh
# ALL the continued lines following this one are interpreted
# by the bourne shell and ignored by Tcl, which picks up
# execution after the exec line.\
for i in tclsh wish 
# execution after the exec line.\
do
# Execute the script using either tclsh or wish \
   $i "$0"
# end of loop \
done
# end of bourne script \
exit 0

#------------------------------------------------------------------------
# Initialize the test
#------------------------------------------------------------------------
source "$env(SRCDIR)/test_utils.tcl"
source "$env(SRCDIR)/test_ftp_utils.tcl"

foreach lib { globus_module \
		  globus_error \
		  globus_object \
		  globus_ftp_client \
		  globus_ftp_client_debug_plugin } {
    load [ eval file join $topbuilddir "swig/.libs/libtcl${lib}.so" ]
}
set SECTION ftp_test
validate_section $SECTION [list GSIFTP]
puts_info 10 "GSIFTP: $TestEnv($SECTION,GSIFTP)"
#------------------------------------------------------------------------
# Main script
#------------------------------------------------------------------------
if { [ catch {
    puts_info 10 "[info nameofexecutable]"
    
    ftp_client_init
    ftp_client_extra_init
	
    set url [ construct_gsiftp_url $TestEnv($SECTION,GSIFTP) ]
	
    puts_info 10 "globus_ftp_client_handle_cache_url_state"
    globus_ftp_client_handle_cache_url_state $copy_info(handle) $url 
	
    puts_info 10 "globus_ftp_client_handle_flush_url_state"
    globus_ftp_client_handle_flush_url_state $copy_info(handle) $url
	
    puts_info 10 "globus_ftp_client_handle_set_user_pointer"
    globus_ftp_client_handle_set_user_pointer $copy_info(handle) NULL
	
    puts_info 10 "globus_ftp_client_handle_get_user_pointer"	      
    lassign [ globus_ftp_client_handle_get_user_pointer \
		  $copy_info(handle) \
		 ] result user_pointer
    puts_info 10 "user_pointer: $user_pointer"
    
    puts_info 10 "globus_ftp_client_handle_add_plugin"
    globus_ftp_client_handle_add_plugin $copy_info(handle) $plugin_t
    
    puts_info 10 "globus_ftp_client_handle_remove_plugin"
    globus_ftp_client_handle_remove_plugin $copy_info(handle) $plugin_t
	
    ftp_client_cleanup
    ftp_client_extra_cleanup
	
} err ] } {
    err_handler $err
}

#------------------------------------------------------------------------
# Exit with normal exit status since test completed without error.
#------------------------------------------------------------------------
TestExit
