#!/bin/sh
# ALL the continued lines following this one are interpreted
# by the bourne shell and ignored by Tcl, which picks up
# execution after the exec line.\
for i in tclsh wish 
# execution after the exec line.\
do
# Execute the script using either tclsh or wish \
   $i "$0"
# end of loop \
done
# end of bourne script \
exit 0

#------------------------------------------------------------------------
# Initialize the test
#------------------------------------------------------------------------
source "$env(SRCDIR)/test_utils.tcl"
source "$env(SRCDIR)/test_ftp_utils.tcl"

foreach lib { globus_module \
		  globus_error \
		  globus_object \
		  globus_ftp_client \
		  globus_ftp_client_debug_plugin } {
    load [ eval file join $topbuilddir "swig/.libs/libtcl${lib}.so" ]
}

#------------------------------------------------------------------------
# Main script
#------------------------------------------------------------------------
if { [ catch {

    puts_info 10 "[info nameofexecutable]"
    
    ftp_client_init
    ftp_client_extra_init
    
    # globus_ftp_client_restart_marker_copy()
    set new_restart_marker_t [ new_globus_ftp_client_restart_marker_t ]
    puts_info 10 "new_restart_marker_t: $new_restart_marker_t"
    
    puts_info 10 "globus_ftp_client_restart_marker_copy"
    globus_ftp_client_restart_marker_copy \
	$new_restart_marker_t \
	$restart_marker_t
    
    puts_info 10 "Reclaim memory space"
    delete_globus_ftp_client_restart_marker_t $new_restart_marker_t
    
    # globus_ftp_client_restart_marker_insert_range()
    puts_info 10 "globus_ftp_client_restart_marker_insert_range"
    globus_ftp_client_restart_marker_insert_range \
	$restart_marker_t \
	256 \
	512

    # globus_ftp_client_restart_marker_set_offset()
    puts_info 10 "globus_ftp_client_restart_marker_set_offset"
    globus_ftp_client_restart_marker_set_offset \
	$restart_marker_t \
	256
    
    # globus_ftp_client_restart_marker_set_ascii_offset()
    puts_info 10 "globus_ftp_client_restart_marker_set_ascii_offset"
    globus_ftp_client_restart_marker_set_ascii_offset \
	$restart_marker_t \
	256 \
	256
    
    # globus_ftp_client_restart_marker_get_total() 
    puts_info 10 "globus_ftp_client_restart_marker_get_total"
    lassign [ globus_ftp_client_restart_marker_get_total \
		  $restart_marker_t \
		 ] result total_bytes
    puts_info 10 "total_bytes: $total_bytes"
    
    # globus_ftp_client_restart_marker_to_string() 
    puts_info 10 "globus_ftp_client_restart_marker_to_string"
    lassign [ globus_ftp_client_restart_marker_to_string \
		  $restart_marker_t \
		 ] result str_rep
    puts_info 10 "str_rep: $str_rep"
    
    puts_info 10 "globus_ftp_client_restart_marker_from_string"
    globus_ftp_client_restart_marker_from_string \
	$restart_marker_t \
	"1024"
    
    ftp_client_cleanup
    ftp_client_extra_cleanup
    
} err ] } {
    err_handler $err
}

#------------------------------------------------------------------------
# Exit with normal exit status since test completed without error.
#------------------------------------------------------------------------
TestExit
