#!/bin/sh
# ALL the continued lines following this one are interpreted
# by the bourne shell and ignored by Tcl, which picks up
# execution after the exec line.\
exec tclsh "$0" ${1+"$@"}

#------------------------------------------------------------------------
# Initialize the test
#------------------------------------------------------------------------

source "$env(SRCDIR)/test_utils.tcl"
source "$env(SRCDIR)/test_ftp_utils.tcl"

foreach lib { globus_module \
		  globus_error \
		  globus_object \
		  globus_ftp_client \
		  globus_ftp_client_debug_plugin } {
    load [ eval file join $topbuilddir "swig/.libs/libtcl${lib}.so" ]
}


#------------------------------------------------------------------------
# Actual demo
#------------------------------------------------------------------------

if { [ catch {

    #--------------------------------------------------------------------
    #
    # Initialize the test
    #
    #--------------------------------------------------------------------
    
    ftp_client_init
    
    #--------------------------------------------------------------------
    #
    # Modification time
    #
    #--------------------------------------------------------------------
    set SECTION ftp_test
    validate_section $SECTION [list FILENAME]

    ftp_client_modification_time [ construct_gsiftp_url \
				       $TestEnv($SECTION,FILENAME) ]

    #--------------------------------------------------------------------
    #
    # Cleanup the test
    #
    #--------------------------------------------------------------------

    ftp_client_cleanup
        
    if { $ExitStatus != 0 } {
	puts "tv_sec result: $tv_sec_value"
	puts "tv_nsec result: $tv_nsec_value"
    }

} err ] } {
    err_handler $err
}

#------------------------------------------------------------------------
# Exit with normal exit status since test completed without error.
#------------------------------------------------------------------------
TestExit
