#!/bin/sh
# ALL the continued lines following this one are interpreted
# by the bourne shell and ignored by Tcl, which picks up
# execution after the exec line.\
exec tclsh "$0" ${1+"$@"}

#------------------------------------------------------------------------
# Load standard packages
#------------------------------------------------------------------------
source "$env(SRCDIR)/test_utils.tcl"
    
foreach lib { globus_error \
		  globus_object \
		  globus_module \
		  gssapi \
		  globus_gram_client \
		  globus_gram_protocol_constants \
		  globus_gram_protocol } {
    load [ eval file join $topbuilddir "swig/.libs/libtcl${lib}.so" ]
}

#------------------------------------------------------------------------
# Actual demo
#------------------------------------------------------------------------
if { [ catch {
    # Activate the modules that are to be used
    puts_info 10 "Activate GRAM module"
    globus_module_activate $globus_gram_client_module

    puts_info 10 "globus_gram_client_version"
    lassign [ globus_gram_client_version ] version
    puts_info 10 "\tversion $version"
    
    puts_info 10 "globus_gram_client_attr_init"
    lassign [ globus_gram_client_attr_init \
		 ] status attr
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tattr $attr"

    puts_info 10 "globus_gram_client_attr_set_credential"
    lassign [ globus_gram_client_attr_set_credential \
		  $attr \
		  $gss_c_no_credential \
		 ] status 
    puts_info 10 "\tstatus $status"
    
    puts_info 10 "globus_gram_client_attr_get_credential"
    lassign [ globus_gram_client_attr_get_credential \
		  $attr \
		 ] status credential
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tcredential $credential"
    
    # Deactivate the modules that are to be used
    puts_info 10 "Deactivate GRAM module"
    globus_module_deactivate $globus_gram_client_module
} err ] } {
    puts_fail "EXCEPTION: $err"
}

#---------------------------------------------------------------------
# Exit with normal exit status since test completed without error.
#---------------------------------------------------------------------
TestExit
