#!/bin/sh
# ALL the continued lines following this one are interpreted
# by the bourne shell and ignored by Tcl, which picks up
# execution after the exec line.\
exec tclsh "$0" ${1+"$@"}

#------------------------------------------------------------------------
# Load standard packages
#------------------------------------------------------------------------
package require Expect

source "$env(SRCDIR)/test_utils.tcl"
source "$env(SRCDIR)/test_gram_client_utils.tcl"

verifyProxy
    
foreach lib { globus_error \
		  globus_object \
		  globus_module \
		  globus_gram_client \
		  globus_gram_protocol_constants \
		  globus_gram_protocol } {
    load [ eval file join $topbuilddir "swig/.libs/libtcl${lib}.so" ]
}

#------------------------------------------------------------------------
# Start the personal gatekeeper
#------------------------------------------------------------------------
init_globus_personal_gatekeeper

#------------------------------------------------------------------------
# Actual demo
#------------------------------------------------------------------------
if { [ catch {
    # Activate the modules that are to be used
    puts_info 10 "Activate GRAM module"
    globus_module_activate $globus_gram_client_module

    set host "$::GRAM"
    puts_info 10 "host $host"
    
    set done 0
    
    puts_info 10 "globus_gram_client_register_ping"
    lassign [ globus_gram_client_register_ping \
		  $host \
		  NULL \
		  { register_ping_cb NULL } \
		 ] status
    puts_info 10 "\tstatus $status"
    
    # Go into the tcl event loop waiting for callbacks to complete
    if { $status == 0 } {
	vwait done
    }
    
    # Deactivate the modules that are to be used
    puts_info 10 "Deactivate GRAM module"
    globus_module_deactivate $globus_gram_client_module
} err ] } {
    puts_fail "EXCEPTION: $err"
    terminate
}
terminate
