#!/bin/sh
# ALL the continued lines following this one are interpreted
# by the bourne shell and ignored by Tcl, which picks up
# execution after the exec line.\
exec tclsh "$0" ${1+"$@"}

#------------------------------------------------------------------------
# Load standard packages
#------------------------------------------------------------------------
source "$env(SRCDIR)/test_utils.tcl"
    
foreach lib { globus_error \
		  globus_object \
		  globus_module \
		  globus_gsi_cred_constants \
		  globus_gsi_credential } {
    load [ eval file join $topbuilddir "swig/.libs/libtcl${lib}.so" ]
}

#------------------------------------------------------------------------
# Actual demo
#------------------------------------------------------------------------
if { [ catch {

    globus_module_activate $globus_i_gsi_credential_module

    puts_info 10 "globus_gsi_cred_handle_attrs_init"
    lassign [ globus_gsi_cred_handle_attrs_init \
		 ] status cred_handle_attrs
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tcred_handle_attrs $cred_handle_attrs"

    puts_info 10 "globus_gsi_cred_handle_attrs_copy"
    lassign [ globus_gsi_cred_handle_attrs_copy \
		  $cred_handle_attrs \
		 ] status dup_cred_handle_attrs
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tdup_cred_handle_attrs $dup_cred_handle_attrs"

    puts_info 10 "globus_gsi_cred_handle_attrs_destroy"
    lassign [ globus_gsi_cred_handle_attrs_destroy \
		  $dup_cred_handle_attrs \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_cred_handle_attrs_set_ca_cert_dir"
    lassign [ globus_gsi_cred_handle_attrs_set_ca_cert_dir \
		  $cred_handle_attrs \
		  "/home/msamidi/.globus/certificates" \
		 ] status
    puts_info 10 "\tstatus $status"
    
    puts_info 10 "globus_gsi_cred_handle_attrs_get_ca_cert_dir"
    lassign [ globus_gsi_cred_handle_attrs_get_ca_cert_dir \
		  $cred_handle_attrs \
		 ] status ca_cert_dir
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tca_cert_dir $ca_cert_dir"

    puts_info 10 "globus_gsi_cred_handle_attrs_set_search_order"
    lassign [ globus_gsi_cred_handle_attrs_set_search_order \
		  $cred_handle_attrs \
		  [list HOST PROXY USER] \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_cred_handle_attrs_get_search_order"
    lassign [ globus_gsi_cred_handle_attrs_get_search_order \
		  $cred_handle_attrs \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_cred_handle_attrs_destroy"
    lassign [ globus_gsi_cred_handle_attrs_destroy \
		  $cred_handle_attrs \
		 ] status
    puts_info 10 "\tstatus $status"
        
    globus_module_deactivate $globus_i_gsi_credential_module
} err ] } {
    puts_fail "EXCEPTION: $err"
}

#---------------------------------------------------------------------
# Exit with normal exit status since test completed without error.
#---------------------------------------------------------------------
TestExit
