#!/bin/sh
# ALL the continued lines following this one are interpreted
# by the bourne shell and ignored by Tcl, which picks up
# execution after the exec line.\
exec tclsh "$0" ${1+"$@"}

#------------------------------------------------------------------------
# Load standard packages
#------------------------------------------------------------------------
source "$env(SRCDIR)/test_utils.tcl"
    
foreach lib { globus_error \
		  globus_object \
		  globus_module \
		  globus_gsi_cred_constants \
		  globus_gsi_credential } {
    load [ eval file join $topbuilddir "swig/.libs/libtcl${lib}.so" ]
}

#------------------------------------------------------------------------
# Actual demo
#------------------------------------------------------------------------
if { [ catch {

    globus_module_activate $globus_i_gsi_credential_module

    puts_info 10 "globus_gsi_cred_handle_attrs_init"
    lassign [ globus_gsi_cred_handle_attrs_init \
		 ] status cred_handle_attrs
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tcred_handle_attrs $cred_handle_attrs"

    puts_info 10 "globus_gsi_cred_handle_init"
    lassign [ globus_gsi_cred_handle_init \
		  $cred_handle_attrs \
		 ] status cred_handle
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tcred_handle $cred_handle"
    
    puts_info 10 "globus_gsi_cred_handle_copy"
    lassign [ globus_gsi_cred_handle_copy \
		  $cred_handle \
		 ] status dup_cred_handle
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tdup_cred_handle $dup_cred_handle"

    puts_info 10 "globus_gsi_cred_handle_destroy"
    lassign [ globus_gsi_cred_handle_destroy \
		  $dup_cred_handle \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_cred_read_proxy"
    lassign [ globus_gsi_cred_read_proxy \
		  $cred_handle \
		  "/tmp/x509up_u4044" \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_cred_get_subject_name"
    lassign [ globus_gsi_cred_get_subject_name \
		  $cred_handle \
		 ] status subject_name
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tsubject_name $subject_name"

    puts_info 10 "globus_gsi_cred_get_issuer_name"
    lassign [ globus_gsi_cred_get_issuer_name \
		  $cred_handle \
		 ] status issuer_name
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tissuer_name $issuer_name"

    puts_info 10 "globus_gsi_cred_get_identity_name"
    lassign [ globus_gsi_cred_get_identity_name \
		  $cred_handle \
		 ] status identity_name
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tidentity_name $identity_name"

    puts_info 10 "globus_gsi_cred_get_cert_type"
    lassign [ globus_gsi_cred_get_cert_type \
		  $cred_handle \
		 ] status cert_type
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tcert_type $cert_type"

    puts_info 10 "globus_gsi_cred_get_key_bits"
    lassign [ globus_gsi_cred_get_key_bits \
		  $cred_handle \
		 ] status key_bits
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tkey_bits $key_bits"
    
    puts_info 10 "globus_gsi_cred_get_handle_attrs"
    lassign [ globus_gsi_cred_get_handle_attrs \
		  $cred_handle \
		 ] status handle_attrs
    puts_info 10 "\tstatus $status"
    puts_info 10 "\thandle_attrs $handle_attrs"

    puts_info 10 "globus_gsi_cred_verify"
    lassign [ globus_gsi_cred_verify \
		  $cred_handle \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_cred_get_lifetime"
    lassign [ globus_gsi_cred_get_lifetime \
		  $cred_handle \
		 ] status lifetime 
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tlifetime $lifetime"

    puts_info 10 "globus_gsi_cred_get_goodtill"
    lassign [ globus_gsi_cred_get_goodtill \
		  $cred_handle \
		 ] status goodtill
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tgoodtill $goodtill"












    
    puts_info 10 "globus_gsi_cred_handle_attrs_destroy"
    lassign [ globus_gsi_cred_handle_attrs_destroy \
		  $cred_handle_attrs \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_cred_handle_destroy"
    lassign [ globus_gsi_cred_handle_destroy \
		  $cred_handle \
		 ] status
    puts_info 10 "\tstatus $status"
    
    globus_module_deactivate $globus_i_gsi_credential_module
    
} err ] } {
    puts_fail "EXCEPTION: $err"
}

#---------------------------------------------------------------------
# Exit with normal exit status since test completed without error.
#---------------------------------------------------------------------
TestExit
