#!/bin/sh
# ALL the continued lines following this one are interpreted
# by the bourne shell and ignored by Tcl, which picks up
# execution after the exec line.\
exec tclsh "$0" ${1+"$@"}

#------------------------------------------------------------------------
# Load standard packages
#------------------------------------------------------------------------
source "$env(SRCDIR)/test_utils.tcl"
    
foreach lib { globus_error \
		  globus_object \
		  globus_module \
		  globus_gsi_proxy } {
    load [ eval file join $topbuilddir "swig/.libs/libtcl${lib}.so" ]
}

#------------------------------------------------------------------------
# Actual demo
#------------------------------------------------------------------------
if { [ catch {

    globus_module_activate $globus_i_gsi_proxy_module

    puts_info 10 "globus_gsi_proxy_handle_attrs_init"
    lassign [ globus_gsi_proxy_handle_attrs_init \
		 ] status proxy_handle_attrs
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tproxy_handle_attrs $proxy_handle_attrs"

    puts_info 10 "globus_gsi_proxy_handle_attrs_copy"
    lassign [ globus_gsi_proxy_handle_attrs_copy \
		  $proxy_handle_attrs \
		 ] status dup_proxy_handle_attrs
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tdup_proxy_handle_attrs $dup_proxy_handle_attrs"

    puts_info 10 "globus_gsi_proxy_handle_attrs_destroy"
    lassign [ globus_gsi_proxy_handle_attrs_destroy \
		  $dup_proxy_handle_attrs \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_proxy_handle_attrs_set_keybits"
    lassign [ globus_gsi_proxy_handle_attrs_set_keybits \
		  $proxy_handle_attrs \
		  512 \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_proxy_handle_attrs_get_keybits"
    lassign [ globus_gsi_proxy_handle_attrs_get_keybits \
		  $proxy_handle_attrs \
		 ] status key_bits
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tkey_bits $key_bits"

    puts_info 10 "globus_gsi_proxy_handle_attrs_set_init_prime"
    lassign [ globus_gsi_proxy_handle_attrs_set_init_prime \
		  $proxy_handle_attrs \
		  11 \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_proxy_handle_attrs_get_init_prime"
    lassign [ globus_gsi_proxy_handle_attrs_get_init_prime \
		  $proxy_handle_attrs \
		 ] status prime
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tprime $prime"

    puts_info 10 "globus_gsi_proxy_handle_attrs_set_clock_skew_allowable"
    lassign [ globus_gsi_proxy_handle_attrs_set_clock_skew_allowable \
		  $proxy_handle_attrs \
		  30 \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_proxy_handle_attrs_get_clock_skew_allowable"
    lassign [ globus_gsi_proxy_handle_attrs_get_clock_skew_allowable \
		  $proxy_handle_attrs \
		 ] status skew
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tskew $skew"
    
    puts_info 10 "globus_gsi_proxy_handle_attrs_destroy"
    lassign [ globus_gsi_proxy_handle_attrs_destroy \
		  $proxy_handle_attrs \
		 ] status
    puts_info 10 "\tstatus $status"
        
    globus_module_deactivate $globus_i_gsi_proxy_module
} err ] } {
    puts_fail "EXCEPTION: $err"
}

#---------------------------------------------------------------------
# Exit with normal exit status since test completed without error.
#---------------------------------------------------------------------
TestExit
