#!/bin/sh
# ALL the continued lines following this one are interpreted
# by the bourne shell and ignored by Tcl, which picks up
# execution after the exec line.\
exec tclsh "$0" ${1+"$@"}

#------------------------------------------------------------------------
# Load standard packages
#------------------------------------------------------------------------
source "$env(SRCDIR)/test_utils.tcl"
    
foreach lib { globus_error \
		  globus_object \
		  globus_module \
		  globus_gsi_cert_utils_constants \
		  globus_gsi_proxy } {
    load [ eval file join $topbuilddir "swig/.libs/libtcl${lib}.so" ]
}

#------------------------------------------------------------------------
# Actual demo
#------------------------------------------------------------------------
if { [ catch {

    globus_module_activate $globus_i_gsi_proxy_module

    puts_info 10 "globus_gsi_proxy_handle_attrs_init"
    lassign [ globus_gsi_proxy_handle_attrs_init \
		 ] status proxy_handle_attrs
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tproxy_handle_attrs $proxy_handle_attrs"

    puts_info 10 "globus_gsi_proxy_handle_attrs_set_keybits"
    lassign [ globus_gsi_proxy_handle_attrs_set_keybits \
		  $proxy_handle_attrs \
		  512 \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_proxy_handle_attrs_set_init_prime"
    lassign [ globus_gsi_proxy_handle_attrs_set_init_prime \
		  $proxy_handle_attrs \
		  11 \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_proxy_handle_attrs_set_clock_skew_allowable"
    lassign [ globus_gsi_proxy_handle_attrs_set_clock_skew_allowable \
		  $proxy_handle_attrs \
		  30 \
		 ] status
    puts_info 10 "\tstatus $status"


    
    puts_info 10 "globus_gsi_proxy_handle_init"
    lassign [ globus_gsi_proxy_handle_init \
		  $proxy_handle_attrs \
		 ] status proxy_handle
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tproxy_handle $proxy_handle"

    puts_info 10 "globus_gsi_proxy_handle_get_keybits"
    lassign [ globus_gsi_proxy_handle_get_keybits \
		  $proxy_handle \
		 ] status key_bits
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tkey_bits $key_bits"

    puts_info 10 "globus_gsi_proxy_handle_get_init_prime"
    lassign [ globus_gsi_proxy_handle_get_init_prime \
		  $proxy_handle \
		 ] status init_prime
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tinit_prime $init_prime"

    puts_info 10 "globus_gsi_proxy_handle_get_clock_skew_allowable"
    lassign [ globus_gsi_proxy_handle_get_clock_skew_allowable \
		  $proxy_handle \
		 ] status skew
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tskew $skew"


    
    puts_info 10 "globus_gsi_proxy_handle_set_time_valid"
    lassign [ globus_gsi_proxy_handle_set_time_valid \
		  $proxy_handle \
		  30 \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_proxy_handle_get_time_valid"
    lassign [ globus_gsi_proxy_handle_get_time_valid \
		  $proxy_handle \
		 ] status time_valid
    puts_info 10 "\tstatus $status"
    puts_info 10 "\ttime_valid $time_valid"

    puts_info 10 "globus_gsi_proxy_handle_set_type"
    lassign [ globus_gsi_proxy_handle_set_type \
		  $proxy_handle \
		  $GLOBUS_GSI_CERT_UTILS_TYPE_GSI_3_IMPERSONATION_PROXY \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_proxy_handle_get_type"
    lassign [ globus_gsi_proxy_handle_get_type \
		  $proxy_handle \
		 ] status cert_type
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tcert_type $cert_type"

    puts_info 10 "globus_gsi_proxy_handle_set_pathlen"
    lassign [ globus_gsi_proxy_handle_set_pathlen \
		  $proxy_handle \
		  256 \
		 ] status
    puts_info 10 "\tstatus $status"
    
    puts_info 10 "globus_gsi_proxy_handle_get_pathlen"
    lassign [ globus_gsi_proxy_handle_get_pathlen \
		  $proxy_handle \
		 ] status pathlen
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tpathlen $pathlen"

    puts_info 10 "globus_gsi_proxy_handle_set_common_name"
    lassign [ globus_gsi_proxy_handle_set_common_name \
		  $proxy_handle \
		  "Michael Samidi 288621" \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_proxy_handle_get_common_name"
    lassign [ globus_gsi_proxy_handle_get_common_name \
		  $proxy_handle \
		 ] status common_name
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tcommon_name $common_name"

    puts_info 10 "globus_gsi_proxy_handle_set_is_limited"
    lassign [ globus_gsi_proxy_handle_set_is_limited \
		  $proxy_handle \
		  $GLOBUS_TRUE \
		 ] status
    puts_info 10 "\tstatus $status"

    puts_info 10 "globus_gsi_proxy_is_limited"
    lassign [ globus_gsi_proxy_is_limited \
		  $proxy_handle \
		 ] status is_limited
    puts_info 10 "\tstatus $status"
    puts_info 10 "\tis_limited $is_limited"

    


    
    puts_info 10 "globus_gsi_proxy_handle_attrs_destroy"
    lassign [ globus_gsi_proxy_handle_attrs_destroy \
		  $proxy_handle_attrs \
		 ] status
    puts_info 10 "\tstatus $status"
    
    puts_info 10 "globus_gsi_proxy_handle_destroy"
    lassign [ globus_gsi_proxy_handle_destroy \
		  $proxy_handle \
		 ] status
    puts_info 10 "\tstatus $status"
        
    globus_module_deactivate $globus_i_gsi_proxy_module
} err ] } {
    puts_fail "EXCEPTION: $err"
}

#---------------------------------------------------------------------
# Exit with normal exit status since test completed without error.
#---------------------------------------------------------------------
TestExit
